import argparse

from ee.kicad.make_bom import make_bom

pretty = True  # we always pretty print the XML

parser = argparse.ArgumentParser(description="Create a bom XML file from a KiCAD schematic")

parser.add_argument("--sch",
                    required=True,
                    metavar="SCH",
                    help="The schematic to read")

parser.add_argument("--out",
                    metavar="FILE",
                    help="The output file")

parser.add_argument("--strategy",
                    metavar="FUNC")

args = parser.parse_args()

new_mode = True

strategy = args.strategy if args.strategy else "ee.kicad.make_bom.MakeBomStrategy"

make_bom(args.sch, args.out, strategy, new_mode, pretty)
