import ee
import sys

raw = ee.read_ltspice_raw(sys.argv[1])

# print("Variables:")
# for i, v in enumerate(raw.variables):
#  print("{:2}: kind: {:20} expression: {}".format(i, v.kind, v.expression))

# for i, v in enumerate(raw.variables):
#  print("{:2}: kind: {:20} expression: {}".format(i, v.kind, v.expression))
#  for p in raw.values[i]:
#    print("  {}".format(p))

x = raw.get_variable(idx=0)
y = raw.get_variable(expression='V(load)')
xs = raw.get_values(y)

import matplotlib

matplotlib.use('Agg')

import matplotlib.pyplot as plt
from matplotlib.ticker import FuncFormatter, MaxNLocator

fig = plt.figure()
ax = fig.add_subplot(111)
ax.plot(xs)
ax.set_xlabel(x.expression)
ax.set_ylabel(y.expression)

with open("ltspice.png", "wb") as f:
    plt.savefig(f, format="png")
